/* $Id: int_entry.S,v 1.24 1997/11/20 16:16:40 jw5 Exp $
generate uniform stack layout before calling exception handlers
(some have an error code on the stack, some don't)

*/

#include <asm/ptrace.h> /* ptregs , offsets */
#include "../include/exclpage.h"
#include "../include/perform.h"
#include "../include/gasp.h"	
#include <linux/linkage.h>


/* #define MEASURE_SYSCALL_PATH */

#ifdef __i486__
#define ALIGN_TEXT	.align	4,0x90
#else
#define ALIGN_TEXT	.align	2,0x90
#endif

#define EMU_IDT_BIT		(0x2)
#define EMU_ERROR_MASK		(0xffff)
#define EMU_SYS_CALL_ENTRY	(0x80)	
#define EMU_SYS_CALL		((EMU_SYS_CALL_ENTRY << 3) + EMU_IDT_BIT) 
#define ENOSYS			38  
#define CF_MASK			0x00000001	 	



#define __label_name(x) x
#define acquire_lock_label_name(x) __label_name(x)__acquire_emulib_lock
#define locked_label_name(x) __label_name(x)__emulib_locked
#define retry_label_name(x) __label_name(x)__retry


#define LOCK_EMU_LIB(case)			\
acquire_lock_label_name(case):			\
	pushl	%eax;				\
						\
retry_label_name(case):				\
	movl	$1, %eax;			\
	xchgl	%eax, EMU_LOCAL_LOCK_ADDRESS;	\
	testl	%eax, %eax;			\
	jnz     locked_label_name(case);	\
						\
	popl	%eax;
	
#define EMULIB_LOCKED(case)			\
locked_label_name(case):			\
	/* eax already pushed */		\
	/* pushl	%eax; */		\
	pushl	%ebx;				\
	pushl	%ecx;				\
	pushl	%edx;				\
	pushl	%esi;				\
	pushl	%edi;				\
						\
	xor	%esi, %esi;			\
	int	$0x33;				\
						\
	popl	%edi;				\
	popl	%esi;				\
	popl	%edx;			        \
	popl	%ecx;				\
	popl	%ebx;				\
	/* popl	%eax; */			\
						\
	jmp	retry_label_name(case);

.file "int_entry.S"
.text

		
/* .globl	_handle_generalized_exception */
ENTRY(real_sys_call)

	LOCK_EMU_LIB(__real_sys_call)
__real_sys_call:
    	movl	%ecx,PTREGS_ADDRESS+OFFS_ECX
	popl	%ecx				/* get return address	*/

    	movl	%eax,PTREGS_ADDRESS+OFFS_ORIG_EAX
	movl 	%esp,PTREGS_ADDRESS+OFFS_UESP	/* save esp */

    	movl	%ecx, PTREGS_ADDRESS+OFFS_EIP	/* save eip		*/
    	leal	PTREGS_ADDRESS+OFFS_EFLAGS, %esp

	clc					/* clear carry		*/
    	movl 	%ebx,PTREGS_ADDRESS+OFFS_EBX

      	movl	%edx,PTREGS_ADDRESS+OFFS_EDX
      	movl	$-ENOSYS, PTREGS_ADDRESS+OFFS_EAX

    	movl	%esi,PTREGS_ADDRESS+OFFS_ESI
      	movl 	%edi,PTREGS_ADDRESS+OFFS_EDI

	pushfl					/* save flags */
	movl	%ebp,PTREGS_ADDRESS+OFFS_EBP
	
	movl	%eax,%ebx

#ifdef	MEASURE_SYSCALL_PATH      
	ASM_RDTSC /* edx scratched, eax contains low paort of time stamp reg */
	movl	%eax, EMULIB_START_ADDRESS
#endif
	movl	$EMULIB_SYSCALL, %edx
	movl	KERNEL_ID_ADDRESS, %esi
	movl	KERNEL_ID_ADDRESS+4, %edi

    
    	xorl	%eax, %eax
	xorl	%ecx, %ecx
	xorl	%ebp, %ebp

#ifdef DEBUG_IPC
	movl	KERNEL_ID_ADDRESS+8, %ebx
#endif	
	int	$0x30
	
#ifdef	MEASURE_SYSCALL_PATH      
	ASM_RDTSC /* edx scratched, eax contains low paort of time stamp reg */
	movl	%eax, EMULIB_STOP_ADDRESS
#endif
/* restore_regs function.
   restores content of registers from saved copy within
   exclusive page and uses a previously set up stack frame to return
*/
/*
 * write everything back from ptregs to registers
 * and simulate iret. Note that return value from syscall
 * is in ptregs.eax!
 * esp is set back to user esp (saved in ptregs)
 */

__real_restore_regs:	

 	movl	PTREGS_ADDRESS+OFFS_UESP, %esp
 	movl	PTREGS_ADDRESS+OFFS_EFLAGS, %eax

    	movl	PTREGS_ADDRESS+OFFS_ECX,%ecx
    	movl	PTREGS_ADDRESS+OFFS_EDX,%edx

    	movl	PTREGS_ADDRESS+OFFS_ESI,%esi
    	movl 	PTREGS_ADDRESS+OFFS_EDI,%edi

    	movl	PTREGS_ADDRESS+OFFS_EBP,%ebp

	pushl	%eax
	pushl	%cs
	
 	movl	PTREGS_ADDRESS+OFFS_EIP, %eax
	movl 	PTREGS_ADDRESS+OFFS_EBX,%ebx

 	pushl	%eax
 	movl	PTREGS_ADDRESS+OFFS_EAX,%eax

	movl	$0,EMU_LOCAL_LOCK_ADDRESS

	iret

    
/* general protection */
ENTRY(entry13)

	LOCK_EMU_LIB(__sys_call)
__sys_call:			
	movl	%eax,PTREGS_ADDRESS+OFFS_ORIG_EAX
	movl 	%ebx,PTREGS_ADDRESS+OFFS_EBX

	movl	%eax,%ebx

    
	movl	(%esp),%eax			/* get error code */	
	movl	%ecx,PTREGS_ADDRESS+OFFS_ECX

	/* check whether it is an idt error raised by 
	   int 0x80 or a normal exception */
	andw	$EMU_ERROR_MASK, %ax
	movl	%edx,PTREGS_ADDRESS+OFFS_EDX
	
	cmpw	$EMU_SYS_CALL, %ax
	jnz	__normal_gp_exception_esi	/* no -> normal_gp_exception */

	/* yes, we have an int 80, prepare system call interface */
	movl	$-ENOSYS, PTREGS_ADDRESS+OFFS_EAX
    	movl	%esi,PTREGS_ADDRESS+OFFS_ESI

    	movl 	%edi,PTREGS_ADDRESS+OFFS_EDI
	movl	%ebp,PTREGS_ADDRESS+OFFS_EBP

	/* We don't save the exception number and error code because
	   it isn't needed to make a system call */
					
	movl	4(%esp),%eax			/* get eip */
	movl	8(%esp),%ecx			/* get cs */

	addl	$2, %eax			/* skip int 80 */
	movl	%ecx, PTREGS_ADDRESS+OFFS_CS	/* save cs */

	movl	%eax, PTREGS_ADDRESS+OFFS_EIP	/* save eip */
	movl	12(%esp), %ecx			/* get eflags */

	andl	$~CF_MASK, %ecx			/* clear carry */
    	
	leal	16(%esp), %esp			/* remove exception frame */
	movl	%ecx,PTREGS_ADDRESS+OFFS_EFLAGS	/* save eflags */

	movl 	%esp,PTREGS_ADDRESS+OFFS_UESP	/* save esp */
#ifdef	MEASURE_SYSCALL_PATH      
	ASM_RDTSC /* edx scratched, eax contains low paort of time stamp reg */
	movl	%eax, EMULIB_START_ADDRESS
#endif
	xorl	%eax, %eax

	xorl	%ecx, %ecx
	movl	$EMULIB_SYSCALL, %edx

	xorl	%ebp, %ebp
	movl	KERNEL_ID_ADDRESS, %esi

	movl	KERNEL_ID_ADDRESS+4, %edi

#ifdef DEBUG_IPC
	movl	KERNEL_ID_ADDRESS+8, %ebx
#endif	
	int	$0x30
	
#ifdef	MEASURE_SYSCALL_PATH      
	ASM_RDTSC /* edx scratched, eax contains low paort of time stamp reg */
	movl	%eax, EMULIB_STOP_ADDRESS
#endif
/* restore_regs function.
   restores content of registers from saved copy within
   exclusive page and uses a previously set up stack frame to return
*/
/*
 * write everything back from ptregs to registers
 * and simulate iret. Note that return value from syscall
 * is in ptregs.eax!
 * esp is set back to user esp (saved in ptregs)
 */

__restore_regs:	

 	movl	PTREGS_ADDRESS+OFFS_UESP, %esp
 	movl	PTREGS_ADDRESS+OFFS_EFLAGS, %eax

    	movl	PTREGS_ADDRESS+OFFS_ECX,%ecx
	movl	PTREGS_ADDRESS+OFFS_EDX,%edx

    	movl	PTREGS_ADDRESS+OFFS_ESI,%esi
	movl 	PTREGS_ADDRESS+OFFS_EDI,%edi

	pushl	%eax
 	movl	PTREGS_ADDRESS+OFFS_EIP, %eax

	pushl	%cs
      	movl	PTREGS_ADDRESS+OFFS_EBP,%ebp

	pushl	%eax
	movl 	PTREGS_ADDRESS+OFFS_EBX,%ebx
    
 	movl	PTREGS_ADDRESS+OFFS_EAX,%eax
	movl	$0,EMU_LOCAL_LOCK_ADDRESS

	iret

__normal_gp_exception_esi:	
#	ke	"general protection"
	movl	%ebx, PTREGS_ADDRESS+OFFS_EAX
	pushl	$13
	jmp	__normal_exception_esi
		
		
/* divide error */
ENTRY(entry0)	
	pushl	$0		/* push missing error code */
	pushl	$0
	jmp	__handle_generalized_exception

/* debug exception */
ENTRY(entry1)
    	/* check for single step exception after a segmentation
	fault, adjust stack and jump back to entry19 */
	cmpl	$SYMBOL_NAME(entry19_fixup), (%esp) 
	jnz	__normal_trap
	addl	$12, %esp
	jmp	SYMBOL_NAME(entry19)
    
__normal_trap:	
    	pushl	$0		/* push missing error code */
	pushl	$1
	jmp	__handle_generalized_exception

/* int 2 nmi */
ENTRY(entry2)
	pushl	$0		/* push missing error code */
	pushl	$2
	jmp	__handle_generalized_exception

/* breakpoint */
ENTRY(entry3)
	pushl	$0		/* push missing error code */
	pushl	$3
	jmp	__handle_generalized_exception

/* overflow */
ENTRY(entry4)
	pushl	$0		/* push missing error code */
	pushl	$4
	jmp	__handle_generalized_exception

/* boundscheck */
ENTRY(entry5)
	pushl	$0		/* push missing error code */
	pushl	$5
	jmp	__handle_generalized_exception

/* invalid opcode */
ENTRY(entry6)
	pushl	$0		/* push missing error code */
	pushl	$6
	jmp	__handle_generalized_exception

/* int 7 */
ENTRY(entry7)
	pushl	$0		/* push missing error code */
	pushl	$7
	jmp	__handle_generalized_exception

/* double fault */
ENTRY(entry8)
	pushl	$8
	jmp	__handle_generalized_exception

/* coprocessor segment overrun */
ENTRY(entry9)
	pushl	$0		/* push missing error code */
	pushl	$9
	jmp	__handle_generalized_exception

/* invalid tss */
ENTRY(entry10)
	pushl	$10
	jmp	__handle_generalized_exception

/* segment not present */
ENTRY(entry11)
	pushl	$11
	jmp	__handle_generalized_exception

/* stack exception */
ENTRY(entry12)
	pushl	$12
	jmp	__handle_generalized_exception

/* general protection (exception 13) moved to end of list to remove jmp */
	
/* page fault */
ENTRY(entry14)
	pushl	$14
	jmp	__handle_generalized_exception

/* int 15 */
ENTRY(entry15)
	pushl	$15
	jmp	__handle_generalized_exception


/* coprocessor error */
ENTRY(entry16)
	pushl	$0		/* push missing error code */
	pushl	$16
	jmp	__handle_generalized_exception

ENTRY(entry17)
	pushl	$0		/* push missing error code */
	pushl	$17
	jmp	__handle_generalized_exception

ENTRY(entry18)
	pushl	$0		/* push missing error code */
	pushl	$18
	jmp	__handle_generalized_exception

/* used for fake_interrupt entry */
ENTRY(entry19)
	nop			/* if we are single stepping, we will
				   catch an exception at this point, 
				   therefore: Don't mess with
				   the stack until we are shure we don't 
				   do single stepping */
.globl SYMBOL_NAME(entry19_fixup)
SYMBOL_NAME_LABEL(entry19_fixup)
	pushl $0 /* push missing error code */
    	pushl	$19
	jmp	__handle_generalized_exception

	
	
__handle_generalized_exception:	

	/* first lock ex_page data */

	LOCK_EMU_LIB(__exception)
/*
 * Fill in required values to ptregs_struct
 *	some are already there
 */ 

	movl	%eax,PTREGS_ADDRESS+OFFS_ORIG_EAX
	movl	%eax,PTREGS_ADDRESS+OFFS_EAX
	movl 	%ebx,PTREGS_ADDRESS+OFFS_EBX
	movl	%ecx,PTREGS_ADDRESS+OFFS_ECX
	movl	%edx,PTREGS_ADDRESS+OFFS_EDX
__normal_exception_esi:	
	movl	%esi,PTREGS_ADDRESS+OFFS_ESI
	movl 	%edi,PTREGS_ADDRESS+OFFS_EDI
	movl	%ebp,PTREGS_ADDRESS+OFFS_EBP
	
	popl	%eax
	movl	%eax,EXCEPTION_NO_ADDRESS
	
/* skipped segment regs in LINUX_ON_L4! */		
	
/* errorcode, eip, cs and eflags are on the stack */
	movl	(%esp),%eax
	movl	4(%esp),%ebx
	movl	%eax,ERROR_CODE_ADDRESS
	movl	%ebx,PTREGS_ADDRESS+OFFS_EIP
	movl	8(%esp),%eax
	movl	12(%esp),%ebx
	movl	%eax,PTREGS_ADDRESS+OFFS_CS
	movl	%ebx,PTREGS_ADDRESS+OFFS_EFLAGS

/* save _user_ esp in ptregs ; set esp to emulib stack.*/

	leal	16(%esp), %esp
	movl 	%esp,PTREGS_ADDRESS+OFFS_UESP
#ifdef	MEASURE_SYSCALL_PATH      
	ASM_RDTSC /* edx scratched, eax contains low paort of time stamp reg */
	movl	%eax, EMULIB_START_ADDRESS
#endif
	xorl	%eax, %eax
	xorl	%ecx, %ecx
	movl	$EMULIB_EXCEPTION, %edx
	movl	$EMULIB_EXCEPTION, %ebx
	xorl	%ebp, %ebp
	movl	KERNEL_ID_ADDRESS, %esi
	movl	KERNEL_ID_ADDRESS+4, %edi

#ifdef DEBUG_IPC
	movl	KERNEL_ID_ADDRESS+8, %ebx
#endif	
    	int	$0x30
#ifdef	MEASURE_SYSCALL_PATH      
	ASM_RDTSC /* edx scratched, eax contains low paort of time stamp reg */
	movl	%eax, EMULIB_STOP_ADDRESS
#endif
/*
 * write everything back from ptregs to registers
 * and simulate iret. Note that return value from syscall
 * is in ptregs.eax!
 * esp is set back to user esp (saved in ptregs)
 */
	jmp	__restore_regs


ENTRY(user_task_init)
    leal    emulib_idt_descr, %eax
    lidt    (%eax)
#    ke	"idt loaded"
    movl    $-1,    %esi    #pager = nil id
    xorl    %eax,   %eax    #get information about thread 0        
    movl    %esi,   %edi    #pager = nil id
    movl    %esi,   %ebx    #preempter=nil id    
    movl    %esi,   %ebp    #preempter=nil id
    movl    %esi,   %ecx    #esp = invalid
    movl    %esi,   %edx    #eip = invalid

    int	    $0x35

    movl    $1,	%eax
    movl    $SYMBOL_NAME(handle_signals), %edx	#eip = handle_signals
    movl    $(USIGNAL_STACK_INIT), %ecx		#esp = end of signal stack

    int	    $0x35

    /* and now activate our new process :) */    
    
/* activate_process function.
   restores content of registers from prepared copy within
   exclusive page to start the process after fork.
   Special function because we can't touch the stack while process creation
*/

ENTRY(activate_process)

	movl 	PTREGS_ADDRESS+OFFS_EBX,%ebx
	movl	PTREGS_ADDRESS+OFFS_ECX,%ecx
	movl	PTREGS_ADDRESS+OFFS_EDX,%edx
	movl	PTREGS_ADDRESS+OFFS_ESI,%esi
	movl 	PTREGS_ADDRESS+OFFS_EDI,%edi
	movl	PTREGS_ADDRESS+OFFS_EBP,%ebp
	movl	PTREGS_ADDRESS+OFFS_EAX,%eax
	leal	PTREGS_ADDRESS+OFFS_EFLAGS, %esp
	popfl
	movl	PTREGS_ADDRESS+OFFS_UESP, %esp

	movl	$0,EMU_LOCAL_LOCK_ADDRESS

/* XXX argh... how can I jmp to the user without touching ptregs after
   releasing the lock and without touching the user stack before??? */
		
	jmp	*(PTREGS_ADDRESS+OFFS_EIP)


EMULIB_LOCKED(__real_sys_call)
EMULIB_LOCKED(__sys_call)
EMULIB_LOCKED(__exception)	

ENTRY(do_nothing_loop)
again:	jmp again

#define D_SEG_PRESENT	0x8000 /*(0x01 << 15)*/
#define D_USER		0x6000 /*(0x03 << 13)*/
#define D_TRAPGATE      0x0f00 /*(0x0f <<  7)*/
     
.MACRO	IDT_ENTRY entry
.AIF	"\entry" EQ ""    
    .long   0
.AELSE
    .long   SYMBOL_NAME(\entry)
.AENDI        
    .long   D_SEG_PRESENT + D_USER + D_TRAPGATE 
.ENDM

/* #define BREAK_POINT_KERNEL_EVENT             */
    .align  4
    .globl  emulib_idt_descr
emulib_idt_descr:
    .word   20 * 8 -1
    .long   idt_table	

    .align  4
    .globl  idt_table
idt_table:  
    IDT_ENTRY	entry0
#ifdef	SINGLE_STEP_KERNEL_EVENT
    IDT_ENTRY
#else
    IDT_ENTRY	entry1
#endif            
    IDT_ENTRY
#ifdef	BREAK_POINT_KERNEL_EVENT
    IDT_ENTRY
#else
    IDT_ENTRY	entry1
#endif            
    IDT_ENTRY	entry4
    IDT_ENTRY	entry5
    IDT_ENTRY	entry6
    IDT_ENTRY	entry7
    IDT_ENTRY	entry8
    IDT_ENTRY	entry9
    IDT_ENTRY	entry10
    IDT_ENTRY	entry11
    IDT_ENTRY	entry12
    IDT_ENTRY	entry13
    IDT_ENTRY	entry14
    IDT_ENTRY	entry15
    IDT_ENTRY	entry16
    IDT_ENTRY	entry17
    IDT_ENTRY	entry18
    IDT_ENTRY	entry19

    .align  4
    .globl  emulib_idt_descr
emulib_debug_idt_descr:
    .word   20 * 8 -1
    .long   debug_idt_table	

    .align  4
    .globl  debug_idt_table
debug_idt_table:  
    IDT_ENTRY	entry0
    IDT_ENTRY	/* entry1 */
    IDT_ENTRY	/* entry2 */
    IDT_ENTRY	/* entry3 */
    IDT_ENTRY	entry4
    IDT_ENTRY	entry5
    IDT_ENTRY	entry6
    IDT_ENTRY	entry7
    IDT_ENTRY	entry8
    IDT_ENTRY	entry9
    IDT_ENTRY	entry10
    IDT_ENTRY	entry11
    IDT_ENTRY	entry12
    IDT_ENTRY	entry13
    IDT_ENTRY	entry14
    IDT_ENTRY	entry15
    IDT_ENTRY	entry16
    IDT_ENTRY	entry17
    IDT_ENTRY	entry18
    IDT_ENTRY	entry19
    
.END 
