/* atmclip.h - Classical IP over ATM */
 
/* Written 1995,1996 by Werner Almesberger, EPFL LRC */
 

#ifndef LINUX_ATMCLIP_H
#define LINUX_ATMCLIP_H

#include <linux/sockios.h>
#include <linux/atmioc.h>


#define CLIP_NULENCAP	SIOCDEVPRIVATE		/* set NULL encapsulation */
#define CLIP_LLCENCAP	(SIOCDEVPRIVATE+1)	/* set LLC/SNAP encap. */


#define RFC1483LLC_LEN	8		/* LLC+OUI+PID = 8 */
#define RFC1626_MTU	9180		/* RFC1626 default MTU */

#define CLIP_DEFAULT_IDLETIMER 1200	/* 20 minutes, see RFC1755 */
#define CLIP_CHECK_INTERVAL	 10	/* check every ten seconds */

#define SIOCMKCLIP	_IO('a',ATMIOC_CLIP)	/* create IP interface */
#define CLIP_PVC	_IO('a',ATMIOC_CLIP+4)	/* IP itf becomes CLIP itf */

#ifdef __KERNEL__

#include <linux/skbuff.h>
#include <linux/atmdev.h>
#include <linux/atm.h>


int atm_init_clip(struct atm_vcc *vcc);

#endif /* __KERNEL__ */

#endif
